#!/bin/bash
#
# Version : 1.0
# Licence : GPL v3
# Maintenance : Christophe LEVEQUE
# Shell : bash
# Modifié par Aciah - août 2022
# LICENSE:      GNU GPL v3 (http://www.gnu.org/licenses/gpl.html)
# 
#   
aplay /usr/local/share/advl/beep.wav
pdftotext -layout /usr/local/share/advl/desactivez.pdf - | espeak -a 200 -v mb-fr1 -s 130            
# Variables :

ICONS="/usr/share/icons/hicolor/48x48/apps/daisy-player.png"
TITLE="Daisy Player - Lecture de : "

# Fonctions :

notify(){
  echo "$1"
  [ "$scr1" = "1" ]  && espeak -v $TYPE -s $SPEED -p $PITCH "$TITLE/. /$1/.  /$Texte/." | mbrola $VOIX - -.au | aplay &
  notify-send -i "$ICONS" "$TITLE" "$1"
  sleep 5
}

##### capture filepath #####
dir=$(pwd)

##### test pour savoir si la lecture est en route #####
if [ -n "$(ps -A | grep mbrola)" ] ; then
	killall -KILL mbrola && sleep 2
fi

##### test et creation dossier ConfigVoix et des fichiers de configuraions #####

if [ ! -d $HOME/.local/ConfigVoix/ ] ; then
     mkdir $HOME/.local/ConfigVoix
     # Voix feminine
     TYPE_VOIX=/usr/share/mbrola/fr4/fr4 
     TYPE_V=mb/mb-fr4 
     # Voix masculine
     #TYPE_VOIX=/usr/share/mbrola/fr1/fr1
     #TYPE_V=mb/mb-fr1
     SPEED_V="160"
     PITCH_V="50"
     cd $HOME/.local/ConfigVoix
     echo $TYPE_VOIX > voix.conf
     echo $TYPE_V > type.conf
     echo $SPEED_V > speed.conf
     echo $PITCH_V > pitch.conf
fi

cd $HOME/.local/ConfigVoix

##### choix du type de voix à utiliser #####

VOIX=$(cat $HOME/.local/ConfigVoix/voix.conf)
TYPE=$(cat $HOME/.local/ConfigVoix/type.conf)
SPEED=$(cat $HOME/.local/ConfigVoix/speed.conf)
PITCH=$(cat $HOME/.local/ConfigVoix/pitch.conf)

if pgrep "orca" > /dev/null; then
    scr=1
else
    scr=0
fi

cd $dir
Document=$@


file=$(basename "$Document")
notify "$file"
x-terminal-emulator -e daisy-player $Document

exit 0
