#!/bin/bash
# VERSION 1.0
# Auteur : association ACIAH - avril 2023
# Licence : GPL - v3
# Modifications :
# Nom : scanner
# DESCRIPTION : Script permettant de scanner et obtenir un document en pdf, jpg et txt
# DEPENDANCES : le script nécessite les paquets pdftotext, scanimage, espeak, tesseract, unoconv
# COMPLEMENTS : le script fait appel à des fichiers sonores et au script lecture.sh
# ce script est placé dans : /home/aciah/.local/scripts/scanner.sh
# Licence : GPL v3
# Fonction : Scanner et Reconnaître - Mousepad
# Maintenance : <aciah@free.fr>
# Shell : bash
#
aplay /usr/local/share/advl/beep.wav
REPSCAN=$HOME/Machine-a-lire/scan
pdftotext -layout /usr/local/share/advl/patientez.pdf - | espeak -a 150 -v mb-fr1 -s 130
#
#la résolution est fixée ci-dessous à 150, elle peut être modifiée
#mkdir $HOME/scan
scanimage -x 210 -y 297 --format=tiff >$REPSCAN/image.tiff --resolution 150
echo "répertoire de scan"  $REPSCAN
sleep 2
#cd $HOME/scan
tesseract $REPSCAN/image.tiff $REPSCAN/document_final
echo "tesseract document final" `ls $REPSCAN`
pdftotext -layout /usr/local/share/advl/docfinal.pdf - | espeak -a 150 -v mb-fr1 -s 130
#pdftotext -layout $REPSCAN/document_final.pdf - | espeak -a 150 -v mb-fr1 -s 130
echo "pdf to text document_final.pdf" `ls $REPSCAN`
# le script lit le document_final.txt
x-terminal-emulator -e /usr/local/bin/player.py $REPSCAN/document_final.txt
#rm $REPSCAN/document_final.txt.*
#rm $REPSCAN/document_final.txt

# on transforme image.tiff en documents pdf et jpg et on supprime image.tiff
unoconv -f pdf $REPSCAN/image.tiff
unoconv -f jpg $REPSCAN/image.tiff
rm $REPSCAN/image.tiff

# et on ouvre le dossier scan
caja $REPSCAN

exit 0
