#!/bin/bash

# Version : 2.0
# Licence : GPL v3
# Fonction : switch voix ORCA
# Maintenance : Christophe LEVEQUE
# Shell : bash

# Variables :

ICONS1="/usr/share/pixmaps/orca.png"

# Fonctions :

stopmbrola(){
  if [ -n "$(ps -A | grep mbrola)" ] ; then
	killall -KILL mbrola && sleep 2
  fi

}

notify(){
  echo "$1""$2""$3"
  stopmbrola
  notify-send -i  "$ICONS" "$TITLE" "$1"
  [ "$scr" = "1" ] && espeak -v $TYPE -s $SPEED -p $PITCH "$TITLE $1 ." | mbrola $VOIX - -.au | aplay 
  sleep "$2"
  
  yad --width=700 --height=250 --center \
  --window-icon "$ICONS" --image "$ICONS" \
  --on-top --undecorated \
  --text-align=center \
  --title "$TITLE - $1" \
  --text "<big><big><big>\n\n$TITLE\n\n $1\n\n</big></big></big>" \
  --timeout="$3" \
  --no-buttons \
  
}


stopmbrola


##### test et creation dossier ConfigVoix et des fichiers de configurations #####

if [ ! -d $HOME/.local/ConfigVoix/ ] ; then
     mkdir $HOME/.local/ConfigVoix
     # Voix feminine
     TYPE_VOIX=/usr/share/mbrola/fr4/fr4 
     TYPE_V=mb/mb-fr4 
     # Voix masculine
     #TYPE_VOIX=/usr/share/mbrola/fr1/fr1
     #TYPE_V=mb/mb-fr1
     SPEED_V="160"
     PITCH_V="50"
     echo $TYPE_VOIX > $HOME/.local/ConfigVoix/voix.conf
     echo $TYPE_V > $HOME/.local/ConfigVoix/type.conf
     echo $SPEED_V > $HOME/.local/ConfigVoix/speed.conf
     echo $PITCH_V > $HOME/.local/ConfigVoix/pitch.conf
fi

if pgrep "orca" > /dev/null; then
    scr=1
else
    scr=0
fi

cd $HOME/.local/ConfigVoix

##### choix du type de voix à utiliser #####

VOIX=$(cat $HOME/.local/ConfigVoix/voix.conf)
TYPE=$(cat $HOME/.local/ConfigVoix/type.conf)
SPEED=$(cat $HOME/.local/ConfigVoix/speed.conf)
PITCH=$(cat $HOME/.local/ConfigVoix/pitch.conf)


##### INITIALISATION ####
if [ ! -d $HOME/.local/ConfigORCA/ ] ; then
    mkdir $HOME/.local/ConfigORCA
fi;

dir="/etc/speech-dispatcher"
cd "$dir"
cp -vf speechd.conf $HOME/.local/ConfigORCA/
cd $HOME/.local/ConfigORCA


# messages
APPNAME="SELECTION Voice for ORCA"
WARN="Actual using voice is :"
TITLE="SELECTION Voice for ORCA  "
HMMSG="Your choice ?"
CHOICE="Choice"
SELECT="selected"

case $LANG in
	fr*)
        APPNAME="SÉLECTION de la Voix pour ORCA"
        WARN="La voix actuellement utilisée est :"
        TITLE="SÉLECTION de la Voix pour ORCA  "
	HMMSG="Votre choix ?"
        CHOICE="Choix"
        SELECT="sélectionnée"
        ;;

esac

### end trads

###### Notification #######
OLDIFS=$IFS
IFS='
'
ICONS=$ICONS1
notify "" "2" "2"

ST=`sed -n -e 100p speechd.conf` && echo $ST > tmp && OLD=`cut -d '"' -f2 < tmp`
STN=""

ARRAY_VOICES=(MALE1 MALE2 MALE3 FEMALE1 FEMALE2)
ARRAY_VOICES_TAB=("Voix masculine 1" "Voix masculine 2" "Voix masculine 3" "Voix féminine 1" "Voix féminine 2")
ARRAY_STATUT=""
ACTUAL_VOICE=""


count=0
for i in ${ARRAY_VOICES[*]} ; do
if [ "$OLD" = "${ARRAY_VOICES[${count}]}" ]; then
	ARRAY_STATUT[${count}]="TRUE"
	ACTUAL_VOICE=${ARRAY_VOICES_TAB[${count}]}
else
	ARRAY_STATUT[${count}]="FALSE"
fi

((++count))
done


STN=$(yad --width=750 --height=450 --center --list --title "$APPNAME : $WARN $ACTUAL_VOICE" --window-icon "$ICONS" --image=$ICONS --on-top --undecorated --text "<b><big><big>\n$TITLE \n\n </big>$WARN $ACTUAL_VOICE\n$HMMSG\n</big></b>"  --text-align=center --separator="|" --button="gtk-ok:0" --button="gtk-cancel:1" --radiolist --column="      $CHOICE      " --column="Voix possible pour ORCA" ${ARRAY_STATUT[0]} "<big>"${ARRAY_VOICES_TAB[0]}"</big>" ${ARRAY_STATUT[1]} "<big>"${ARRAY_VOICES_TAB[1]}"</big>" ${ARRAY_STATUT[2]} "<big>"${ARRAY_VOICES_TAB[2]}"</big>" ${ARRAY_STATUT[3]} "<big>"${ARRAY_VOICES_TAB[3]}"</big>" ${ARRAY_STATUT[4]} "<big>"${ARRAY_VOICES_TAB[4]}"</big>")
#
SETTINGSRET="$?"
if [ "$SETTINGSRET" != "0" ] ; then 
 	NEW_VOICE=$ACTUAL_VOICE
 	notify "Aucune modification effectuée" "2" "2"
 	IFS=$OLDIFS
 	exit 0
else
	NEW_VOICE="`echo $STN | cut -d ">" -f2 | cut -d "<" -f1`"
fi
if [ "$NEW_VOICE" = "$ACTUAL_VOICE" ] ; then 
 	notify "Aucune modification effectuée" "2" "2"
 	IFS=$OLDIFS
 	exit 0
fi
count=0
for i in ${ARRAY_VOICES[*]} ; do
if [ "$NEW_VOICE" = "${ARRAY_VOICES_TAB[${count}]}" ]; then
	NEW=${ARRAY_VOICES[${count}]}
fi
((++count))
done
echo $OLD $NEW

notify "La voix sélectionnée est : $NEW_VOICE" "2" "2"
notify "La $ACTUAL_VOICE sera remplacée par la $NEW_VOICE" "2" "2"

NST="DefaultVoiceType "'"'$NEW'"'""
echo $NST
while read a ; do echo ${a//$ST/$NST} ; done < speechd.conf > speechd.conf.t ; mv speechd.conf{.t,}

gksudo --m "Entrez votre mot de passe SVP" cp speechd.conf "$dir"/speechd.conf
sleep 2

if pgrep "orca" > /dev/null; then
     killall orca &
     fl=1
else
     fl=0
fi
killall -u `whoami` speech-dispatcher

sleep 2
speech-dispatcher

if [ "$fl" = "1" ] ; then
    orca --replace &
fi

IFS=$OLDIFS
exit 0
