# VERSION :     1.0   
# Date  : 7/12/2021
# AUTHOR:       Jean-Yves ROCHER
# NAME:         A-Lire et obtenir le texte.sh
# DESCRIPTION:  Script pour lire avec la machine à lire des images jpg, png, tif et des fichiers PDF
# REQUIRES:     ghostscript, poppler-utils, xpdf, [ "$scr" = "1" ] && espeak, mbrola, notify-send, xsane, xsane-common, sane, libsane,libsane-common, sane-utils, convert, tesseract-ocr, libtesseract3, tesseract-ocr-osd, tesseract-ocr-eng, tesseract-ocr-fra, tesseract-ocr-equ - d'autres langues disponibles dans les dépots : tesseract-ocr-<langue> (options : cuneiform, cuneiform-common, libcuneiform0)
# LICENSE:      GNU GPL v3

#
ACIAHLOG="/var/log/aciah"
#exec 1>>$ACIAHLOG/machineALire.log 2>>1
if pgrep "orca" > /dev/null; then
        killall orca &
        sleep 2
        killall -9 speech-dispatcher &
fi
pdftotext -layout /usr/local/share/advl/patientez.pdf - | espeak -a 200 -v mb-fr1 -s 150
File="$1"
FILE=`basename ${File%.*}`
TYPE=`mimetype -b $File`
REPLECTURE="$HOME"/Machine-a-lire
File=`basename $File`
CHEMIN=`dirname $1`
	if [ $CHEMIN = "." ]
	then
	sudo updatedb
	CHEMIN=`locate -n 1 $File`
	CHEMIN=`dirname $CHEMIN`
	fi

cd $CHEMIN
#
#
######### Fichier PDF    #######
#

if [ ! -z `echo $TYPE  | grep -i 'pdf'` ]; then
	(echo "0" ;convert -density 200  "$FILE.pdf" "$REPLECTURE"/"${FILE%.*}.jpg"; echo "100" ) |  (yad --progress --pulsate --progress-text="Veuillez patienter" --auto-close --center --width=350 --height=150 --window-icon="$ICONS1" --on-top --undecorated --no-buttons --text-align=center --title="Machine à lire - Veuillez petientez" --text="<big><big><b>Machine à lire\n\Veuillez patienter</b></big></big>") | while [ "$(pidof yad)" ]; do aplay /usr/local/share/advl/beep.wav ;  sleep 3 ; done
IFS=$OLDIFS
	cd $REPLECTURE	
#	pdftotext -layout /usr/local/share/advl/patientez.pdf - | espeak -a 250 -v mb-fr1 -s 150
       		(echo "0" ; convert "$FILE"*.jpg ${FILE%.jpg}.tif ;  echo "100") | (yad --progress --pulsate --progress-text="Veuillez patienter" --auto-close --center --width=350 --height=150 --window-icon="$ICONS1" --on-top --undecorated --no-buttons --text-align=center --title="Machine à lire - Veuillez petientez" --text="<big><big><b>Machine à lire\n\Veuillez patienter</b></big></big>") | while [ "$(pidof yad)" ]; do aplay /usr/local/share/advl/beep.wav ;  sleep 3 ; done
#pdftotext -layout /usr/local/share/advl/patientez.pdf - | espeak -a 250 -v mb-fr1 -s 150
        (echo "0" ; OMP_THREAD_LIMIT=1 tesseract $FILE.tif $FILE -l fra ;  echo "100") | (yad --progress --pulsate --progress-text="Veuillez patienter" --auto-close --center --width=350 --height=150 --window-icon="$ICONS1" --on-top --undecorated --no-buttons --text-align=center --title="Machine à lire - Veuillez petientez" --text="<big><big><b>Machine à lire\n\Veuillez patienter</b></big></big>") | while [ "$(pidof yad)" ]; do aplay /usr/local/share/advl/beep.wav ;  sleep 3 ; done
rm $REPLECTURE/$FILE.tif
rm $REPLECTURE/"$FILE"*.jpg
#
else
echo "ce n est pas un fichier pdf"
fi
###########    fichier png    #############

if [ ! -z `echo $TYPE  | grep -i 'png'` ]; then
	convert -background black -flatten $CHEMIN/$FILE.png "$REPLECTURE/$FILE.jpg" ;
	cd $REPLECTURE
for  page in "$FILE"*.jpg ;do
                 convert $page ${page%.jpg}.tif ;
                done
	#
	(echo "0" ;OMP_THREAD_LIMIT=1 tesseract $FILE.tif $FILE -l fra ;  echo "100") | (yad --progress --pulsate --progress-text="Veuillez patienter" --auto-close --center --width=350 --height=150 --window-icon="$ICONS1" --on-top --undecorated --no-buttons --text-align=center --title="Machine à lire - Veuillez petientez" --text="<big><big><b>Machine à lire\n\Veuillez patienter</b></big></big>") | while [ "$(pidof yad)" ]; do aplay /usr/local/share/advl/beep.wav ; sleep 2 ; done
rm $REPLECTURE/$FILE.tif
rm $REPLECTURE/$FILE.jpg

else
echo "ce n est pas un fichier png"
fi
###########    fichier tif    #############

if [ ! -z  `echo $TYPE  | grep -i 'tiff'` ]; then
        cp $CHEMIN/$FILE.tif "$REPLECTURE"/
        cd $REPLECTURE
        #
        (echo "0" ;OMP_THREAD_LIMIT=1 tesseract $FILE.tif $FILE -l fra ;  echo "100") | (yad --progress --pulsate --progress-text="Veuillez patienter" --auto-close --center --width=350 --height=150 --window-icon="$ICONS1" --on-top --undecorated --no-buttons --text-align=center --title="Machine à lire - Veuillez petientez" --text="<big><big><b>Machine à lire\n\Veuillez patienter</b></big></big>") | while [ "$(pidof yad)" ]; do aplay /usr/local/share/advl/beep.wav ; sleep 2 ; done
rm $REPLECTURE/$FILE.tif

else
echo "ce n est pas un fichier tif"
fi
###########    fichier jpg    #############
if [ ! -z `echo $TYPE  | grep -i 'jpeg'` ]; then
	cp $CHEMIN/$FILE.jpg "$REPLECTURE"/
        cd $REPLECTURE
        for  page in "$FILE"*.jpg ;do
                 convert $page ${page%.jpg}.tif ;
                done
        #
        (echo "0" ;OMP_THREAD_LIMIT=1 tesseract $FILE.tif $FILE -l fra ;  echo "100") | (yad --progress --pulsate --progress-text="Veuillez patienter" --auto-close --center --width=350 --height=150 --window-icon="$ICONS1" --on-top --undecorated --no-buttons --text-align=center --title="Machine à lire - Veuillez petientez" --text="<big><big><b>Machine à lire\n\Veuillez patienter</b></big></big>") | while [ "$(pidof yad)" ]; do aplay /usr/local/share/advl/beep.wav ; sleep 2 ; done

rm $REPLECTURE/$FILE.tif
rm $REPLECTURE/$FILE.jpg
else
echo "ce n est pas un fichier tif"
fi
####### fin des conversions   #####
echo '$REPLECTURE"/"$FILE.txt' "$REPLECTURE"/"$FILE.txt"
echo '$CHEMIN/$FILE.txt' "$CHEMIN"/"$FILE".txt
cp -f "$REPLECTURE"/"$FILE.txt" "$CHEMIN"/"$FILE".txt
pdftotext -layout /usr/local/share/advl/lire.pdf - | espeak -a 300 -v mb-fr1 -s 150
sh $HOME/.config/orca/scripts/orca-switch.sh
sleep 2
tr  "\n" " " <  $FILE.txt > "$FILE"Alire.txt
mousepad "$FILE"Alire.txt
rm "$FILE"Alire.txt
if pgrep "orca" > /dev/null; then
        killall orca &
        sleep 2
        killall -9 speech-dispatcher &
fi

pdftotext -layout /usr/local/share/advl/terminer.pdf - | espeak -a 200 -v mb-fr1 -s 150
sleep 2
exit
